
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Media_assetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        asset_type: data.asset_type
        ||
        null
            ,
            
        alt_text: data.alt_text
        ||
        null
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await media_assets.setUploaded_by( data.uploaded_by || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'images',
                belongsToId: media_assets.id,
            },
            data.images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'files',
                belongsToId: media_assets.id,
            },
            data.files,
            options,
        );
        

        return media_assets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const media_assetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                asset_type: item.asset_type
            ||
            null
            ,
            
                alt_text: item.alt_text
            ||
            null
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const media_assets = await db.media_assets.bulkCreate(media_assetsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < media_assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.media_assets.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: media_assets[i].id,
                },
                data[i].images,
                options,
            );
        }
        
        for (let i = 0; i < media_assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.media_assets.getTableName(),
                    belongsToColumn: 'files',
                    belongsToId: media_assets[i].id,
                },
                data[i].files,
                options,
            );
        }
        

        return media_assets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const media_assets = await db.media_assets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.asset_type !== undefined) updatePayload.asset_type = data.asset_type;
        
        
        if (data.alt_text !== undefined) updatePayload.alt_text = data.alt_text;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await media_assets.update(updatePayload, {transaction});

        
        
        if (data.uploaded_by !== undefined) {
            await media_assets.setUploaded_by(
              
              data.uploaded_by,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'images',
                belongsToId: media_assets.id,
            },
            data.images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'files',
                belongsToId: media_assets.id,
            },
            data.files,
            options,
        );
        

        return media_assets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of media_assets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of media_assets) {
                await record.destroy({transaction});
            }
        });


        return media_assets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.findByPk(id, options);

        await media_assets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await media_assets.destroy({
            transaction
        });

        return media_assets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.findOne(
            { where },
            { transaction },
        );

        if (!media_assets) {
            return media_assets;
        }

        const output = media_assets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.images = await media_assets.getImages({
            transaction
        });
        
        
        output.files = await media_assets.getFiles({
            transaction
        });
        
        
        output.uploaded_by = await media_assets.getUploaded_by({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'uploaded_by',
        
        where: filter.uploaded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'images',
      },

      {
        model: db.file,
        as: 'files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'media_assets',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.alt_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'media_assets',
                        'alt_text',
                        filter.alt_text,
                    ),
                };
            }
            

            
            

            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.asset_type) {
                where = {
                    ...where,
                asset_type: filter.asset_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.media_assets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'media_assets',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.media_assets.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

